Packages - Bug #3414

Black screen after suspend
2022-12-31 05:44 PM - nona

Status: info needed % Done: 0%
Priority: bug

Assignee:

Category:
steps to reproduce:
0. (consult dm-crypt/Encrypting an entire system)

. create a GPT partition table (fdisk /dev/sdX, where /dev/sdX is a drive not a partition; then set to GPT with g and create

partitions as needed)

. encrypt a partition with LUKS ( cryptsetup luksFormat /dev/sdXY, where /dev/sdX is a drive, and /dev/sdXY is a partition on the

drive )

. decrypt the partition ( cryptsetup luksOpen /dev/sdXY crypt )

. create a logical volume on the decrypted partition ( pvcreate /dev/mapper/crypt vgcreate mylvm /dev/mapper/crypt )

. create a swap partition ( Ivcreate -L $size mylvm -n myswap ) on the logical volume (besides your system)

. install GRUB on your system and install the boot loader ( grub-install --target=i386-pc /dev/sdX )

. get the UUID of your logical swap partition ( blkid -s UUID -o value /dev/mylvm/myswap ; example output: XXX-XXX-XXX)
. add an entry with /dev/mylvm/myswap none swap sw 0 0 into /etc/fstab

.add resume to the hooks in /etc/mkinitcpio.conf

.add resume=UUID=xxx-xxx-xxx to /etc/default/grub into the GRUB_CMDLINE_LINUX (also add

cryptdevice=UUID=yyy-yyy-yyy:crypt . With a LUKS1 partition for boot, add cryptkey=rootfs:/your_key too, and /your_key to
FILES in /etc/mkinitcpio.conf )

11. add nomodeset to /etc/default/grub into the GRUB_CMDLINE_LINUX
12. install OpenRC and uninstall SystemD
13. install LXDE or ice WM, reboot, login, close the lid
14. open the lid to bring back from suspend
e expected result:
a GUI or some sort of prompt for a password
e actual result:
empty black screen (reminds me of the blue screen of death)
e other
tested with linux-libre, linux-libre-lts, linux-libre-hardened
linux-libre 5.18.14-1
linux-libre-api-headers 5.17.3_gnu-1
linux-libre-hardened 5.18.12.hardened1-1
linux-libre-headers 5.18.14-1
linux-libre-lts 5.15.72-1
History

#1 - 2022-12-31 06:08 PM - wael

- Status changed from unconfirmed to info needed

More information to debug is needed:

1. What kind of system is this? | presume a laptop from the description, but what model?
2.In case it is a system running non-OEM firmware, please state the version.
3. Does the system wake up from sleep at all? (I.E.: Is it only that the screen is dark) or does it stay stuck in sleep?

If you manage to get the logs that would help debugging the issue quite immensely.

#2 - 2022-12-31 06:10 PM - anonymous

| think need see video card information, information about using driver in part of suspend support. For example
https://nouveau.freedesktop.org/FeatureMatrix.html. What GPU you have?
#3 - 2022-12-31 08:43 PM - nona
- File Ispci_and_logs.tar.gz added
Sorry, | forgot to add the logs. Here they are.

The system seems to wake up to a blank screen. | can push the "power-off" button once and it does shut down.

#4 - 2022-12-31 09:35 PM - bill-auger

03:00.0 VGA compatible controller [0300]: Advanced Micro Devices, Inc. [AMD/ATI] Raven Ridge [Radeon Vega Series / Radeon Vega Mobile
Series] [1002:15dd] (rev c4) (prog-if 00 [VGA controller])
Subsystem: Hewlett-Packard Company Radeon Vega 8 Mobile [103c:83c6]

h-node has no listing for the graphics card; but that is probably not the problem

have you 'nonsystemd/polkit' installed?

$ pacman -Qs polkit

also, IIRC DMs can interfere with resume - lightdm has been rather flakey - if using a DM, you could try a different one, such as LXDM (or none, just
“startx’)

if you are launching X as unprivileged user, you could also try “startx” as root, to see if you get the same behaviour
#5 - 2022-12-31 10:53 PM - nona
bill-auger wrote:

h-node has no listing for the graphics card; but that is probably not the problem

Hopefully--really, really--that's not the case, but | have had so much trouble with this GPU (roll eyes). Also, | have nomodeset (as a reminder).

have you 'nonsystemd/polkit' installed?

pacman -Qs | grep nonsystemd

local/polkit 121-1.nonsystemdl
also, IIRC DMs can interfere with resume - lightdm has been rather flakey - if using a DM, you could try a different one, such as LXDM (or none,
just “startx’)

LightDM and LXDM give the same result (besides closing the lid, | also tried with Suspend from the Log-out menu with the latter)

if you are launching X as unprivileged user, you could also try “startx” as root, to see if you get the same behaviour

Summary: does the same thing; now | am sure that it comes back, the screen just happens to be black (read below for details):

This was interesting: | don't have xterm, and | got an error when | tried to run startx (became root with su). While still in the terminal (the one after
OpenRC and before any DM or startx), | decided to close the lid. The black screen was back when | opened it again, but then | typed echo "hello".
After rebooting, | was able to see the command in /root/.bash_history.

| did a rc-service Ixdm start and the Suspend option from the log-out menu did the same (as described above). Does this count as " startx™ as root"?

Secondly, | have scripts (.xinitrc, .bash_profile, .xserverrc) to launch the WM (window manager). At this point they were disabled. This means that |
have also tried without a DM (display manager; also known as graphical login greeter).

Thank you very much.

#6 - 2022-12-31 11:22 PM - bill-auger
maybe try different power managers now
# pacman -Ssg power-manager
gnome-power-manager

xfced-power—-manager
mate-power—-manager
ukuli-power-manager

sry i dont have much experience with laptops - my openrc system has no power manager installed - IIRC, there are some special requirements for
mkinitcpio hooks (‘suspend’, 'resume’, or similar), and those could be different for openrc vs systemd

openrc also had some special requirements of permission groups

$ groups

my openrc system's X user belongs to these system groups - IIRC, these were the wiki recommendation at one time

sys video storage disk optical audio

#7 - 2023-01-01 10:54 AM - nona

Hi, bill. I've got progress. After doing the following, my screen and keyboard is frozen; after hitting the power button, there is a blinking underscore;
hitting CTRL+ALT+F1 takes me back to my graphical desktop (I will be using the notation of Emac's Org):

#+begin_src bash :dir /sudo::/
echo 1 > /sys/power/pm_trace
echo s2idle > /sys/power/mem_sleep & echo freeze > /sys/power/state
#+end_src

For whomever is interested, this may also be useful

#+begin_src bash :dir /sudo::/
pacman -Rnucs acpi
#+end_src

/usr/lib/modules/5.18.14-gnu-1/build/Documentation/admin-guide/pm/suspend-flows.rst
/usr/lib/modules/5.18.14-gnu-1/build/Documentation/admin-guide/pm/sleep-states.rst
#+name: s2idle_sleep_states.rst
#+begin_quote

Suspend-to-Idle

It is always

supported if the :c:macro: CONFIG_SUSPEND  kernel configuration option is set.
#+end_quote
#+begin_quote

Standby

The set of devices that can wake up the system from this state usually is
reduced relative to :ref: suspend-to-idle &lt;s2idle&gt;  {how do I know if my hardware is compatible?}

This state is supported if the :c:macro: CONFIG_SUSPEND  kernel configuration

option is set and the support for it is registered by the platform with the

core system suspend subsystem. On ACPI-based systems this state is mapped to

the S1 system state defined by ACPI. {how do I send that signal? get it into that state? /proc...?}
#+end_quote
#+begin_quote

Suspend-to-RAM

In particular, on ACPI-based

systems the kernel passes control to the platform firmware (BIOS) as the last

step during S2RAM transitions and that usually results in powering down some

more low-level components that are not directly controlled by the kernel. {is the BIOS the culprit?}

On ACPI-based systems S2RAM requires some minimal boot-strapping code in the
platform firmware to resume the system from it {does mkinitcpio have what it needs? is my hardware suppo
rted?}

The set of devices that can wake up the system from S2RAM usually is reduced

relative to :ref: suspend-to-idle &lt;s2idle&gt;  and :ref: standby &lt;standby&gt;’ and it
may be necessary to rely on the platform for setting up the wakeup functionality

as appropriate. {how do I know if my hardware is compatible?}

S2RAM 1is supported if the :c:macro: CONFIG_SUSPEND  kernel configuration option
is set and the support for it is registered by the platform with the core system
suspend subsystem. On ACPI-based systems it is mapped to the S3 system state
defined by ACPI.

#+end_quote

#+begin_quote
Basic " "sysfs’® Interfaces for System Suspend and Hibernation
The power management ... provides ... a unified "~ sysfs’°
interface ... regardless of the underlying system architecture
located in the :file: /sys/power/®

‘state™”
This file contains a list of strings representing sleep states supported
by the kernel. Writing one of these strings into it causes the kernel
to start a transition of the system into the sleep state represented by
that string.

the "disk", "freeze" and "standby" strings represent the
:ref: hibernation &lt;hibernation&gt; , :ref: suspend-to-idle &lt;s2idles&gt;  and
:ref: standby &1lt;standbyé&gt;  sleep states, respectively. The "mem" string
is interpreted in accordance with ... the "~ "mem_sleep "~ file...

If the kernel does not support any system sleep states, this file is
not present.
#+end_quote
#+begin_src bash
cat /sys/power/state
#+end_src

#+caption: Should I remove these?
#+RESULTS:
freeze mem

#+begin_quote
" mem_sleep”

The strings that may be present in this file are "s2idle", "shallow"

and "deep". The "s2idle" string always represents :ref: suspend-to-idle
&1lt;s2idles&gt; " and, by convention, "shallow" and "deep" represent

:ref: standby &lt;standby&gt;  and :ref:’ suspend-to-RAM &lt;s2ramé&gt; ,
respectively.

#+end_quote

#+begin_src bash
cat /sys/power/mem_sleep
#+end_src

#+caption: It is going into s2idle ([[s2idle_sleep_states.rst]])
#+RESULTS:
s2idle [deep]

#+begin_quote
According to the above, there are two ways to make the system go into the

:ref: suspend-to-idle &lt;s2idle&gt;  state. The first one is to write "freeze"
directly to :file:’/sys/power/state . The second one is to write "s2idle" to
:file:’ /sys/power/mem_sleep’ and then to write "mem" to

:file:  /sys/power/state’. Likewise, there are two ways to make the system go

into the :ref: standby &lt;standbyé&gt;  state (the strings to write to the control
files in that case are "standby" or "shallow" and "mem", respectively) if that
state 1s supported by the platform. However, there is only one way to make the
system go into the :ref:  suspend-to-RAM &lt;s2ram&gt;  state (write "deep" into
:file:  /sys/power/mem_sleep’ and "mem" into :file:’/sys/power/state’).

#+end_quote

#8 - 2023-01-02 12:22 AM - nona
bill-auger wrote:

maybe try different power managers now

xfce4-power-manager also put the computer into suspend mode, and a black screen when resuming. It did this with and without

HandlelLidSwitch=ignore
HandlelLidSwitchExternalPower=ignore

in /etc/elogind/logind.conf (https:/forum.xfce.org/viewtopic.php?pid=52468#p52468 ; https:/forum.artixlinux.org/index.php/topic,282.0.html )

Before installing xfce4-power-manager , this produces the reported error as well (black screen when resuming).
#+begin_src bash :dir /sudo::/
echo 1 > /sys/power/pm_trace

2024-04-10 4/5


https://forum.xfce.org/viewtopic.php?pid=52468#p52468
https://forum.artixlinux.org/index.php/topic,282.0.html

echo shallow > /sys/power/mem_sleep & echo mem > /sys/power/state
#+end_src

Screen is dark, power button blinks. Pressing the power button brings the computer back into a black screen.
sry i dont have much experience with laptops - my openrc system has no power manager installed - IIRC, there are some special requirements
for mkinitcpio hooks ('suspend', 'resume’, or similar), and those could be different for openrc vs systemd
| have resume in the hooks, but I'll have to check if more are needed.
openrc also had some special requirements of permission groups
[$ groups]
Yep, my user is part of the club
| am assuming that the commands above (echo shallow...) go directly to the kernel power management. Since (1) the s2idle does not turn off the

screen and shallow does, and (2) the system is still operative with s2idle, | think that some how the screen is turned off, but not turned back on. A
lingering question is how to make use of the pm_trace to debug.

Files

Ispci_and_logs.tar.gz 6.6 KB 2022-12-31 nona
